(function ($) {

function toggle_pool_conditions () {
	var $check = $("#esi-not_in_the_pool"),
		$target = $("#esi-conditions-container")
	;
	if (!$check.is(":checked")) $target.show();
	else $target.hide();
}

function toggle_show_after_overrides () {
	var $check = $("#esi-override_show_if"),
		$target = $("#esi-show_after_overrides-container")
	;
	if ($check.is(":checked")) $target.show();
	else $target.hide();
}

function toggle_content_types () {
	var $check = $(':radio[name="esi-type[content_type]"]');
	if (!$check.length) return false;

	var selected_raw = $check.filter(":checked").val(),
		selected = selected_raw || 'text',
		$item = $("#esi-content_type-options-" + selected),
		$editor = $(".postarea")
	;
	if (!$item.length) return false;

	$('.esi-content_type').hide();
	$item.show();

	if ('related' == selected || 'widgets' == selected) $editor.hide();
	else $editor.show();
}

function toggle_reshow_conditions () {
	var $check = $(':radio[name="esi[on_hide]"]');
	if (!$check.length) return false;

	var selected = $check.filter(":checked").val(),
		reshow = !!selected,
		$item = $(".esi-reshow_after")
	;
	if (reshow) $item.show('medium');
	else $item.hide('medium');
	return false;
}


$(function () {


	$(':radio[name="esi-type[content_type]"]').on("change", toggle_content_types);
	toggle_content_types();

	$("#esi-not_in_the_pool").on("change", toggle_pool_conditions);
	toggle_pool_conditions();

	$("#esi-override_show_if").on("change", toggle_show_after_overrides);
	$('[name="esi[show_after-condition]"]').on("change", function () {
		$('[name="esi[show_after-rule]"]').attr("disabled", true);
		$(this).parent("div").find('[name="esi[show_after-rule]"]').attr("disabled", false);
	});
	toggle_show_after_overrides();

	$(':radio[name="esi[on_hide]"]').on("change", toggle_reshow_conditions);
	toggle_reshow_conditions();

	// Add fieldset clearing links
	$("#esi-conditions-container fieldset").each(function () {
		$(this)
			.append('<a href="#clear-set" class="esi-clear_set">' + l10nesi.clear_set + '</a>')
			.find("a.esi-clear_set").on("click", function () {
				$(this).parents("fieldset").first().find(":radio").attr("checked", false);
				return false;
			});
		;
	});

	// Width toggling
	$("#esi-full_width").on("change", function () {
		if (!$("#esi-full_width").is(":checked")) {
			$("#esi-custom_width").show().find("input").attr("disabled", false);
			$('label[for="esi-full_width"]').addClass("esi-not_applicable");
		} else {
			$("#esi-custom_width").hide().find("input").attr("disabled", true);
			$('label[for="esi-full_width"]').removeClass("esi-not_applicable");
		}
	});
});

})(jQuery);